# 4.1 第一个Rust程序 -- 你好，世界！

> 学习一门新程序设计语言的唯一途径就是使用它编写程序。  
> 对于所有初学者来说，编写的第一个程序几乎都是相同的，即：    
>  
> 打印 *hello, world*  
>
> -- Brian Kernighan 《The C Programming Language》

## 4.1.1 第一个Rust程序

Rust的HelloWorld程序和某些其它语言很相似，非常简洁明了。

1. 首先，创建一个名为'hello.rs'的文件。  

    >注意这里用的后缀名是.rs，一般编程语言的代码文件都有惯用的后缀名，比如：
    C语言是.c，java是.java，python是.py等等，**请务必记住Rust语言的惯用后缀名是.rs**（虽然用别的后缀名也能通过rustc的编译）。  

2. 用你喜欢的编辑器编辑hello.rs，输入以下代码

```rust
fn main(){
    println!("hello world!");
}
```

3. 保存上面的代码后，我们发现hello.rs只是一个包含代码的文本文件，并不能直接运行。
我们需要把包含rust代码的文本文件转化成可执行文件，这个过程叫做**编译**，我们可以通过以下命令来编译这段代码

```
rustc hello.rs
```

4. 如果程序没有什么错误（比如漏掉或拼错字符），我们的程序将顺利通过编译，生成一个可执行文件hello，可以输入以下命令运行它

```
./hello
```

5. 可以看到运行结果，将会打印输出：

```
hello world!
```

太棒了，这可能是你用Rust写的第一个程序，但它确实是一个完整的程序。

## 4.1.2 简单的讲解

我们已经用rust编写第一个可执行程序，打印出了'hello world!'，很酷，对吧！  
但是这段代码到底是什么意思呢，作为新手的你一定云里雾里吧，让我们先看一下这个程序：

- 第一行中 fn 表示定义一个**函数**，main是这个函数的名字，花括号{}里的语句则表示这个函数的内容
- 名字叫做**main**的函数有特殊的用途，那就是作为程序的入口，也就是说程序每次都从这个函数开始运行
- 函数中只有一句 ```println!("hello world!");```，这里```println!```是一个Rust语言自带的**宏**，
这个宏的功能就是打印文本(结尾会换行)，而"hello world!"这个用引号包起来的东西是一个**字符串**，就是我们要打印的文本啦
- 你一定注意到了```;```吧， 在Rust语言中，分号```;```用来把语句分隔开，也就是说语句的末尾一般用分号做为结束标志

你可以试试把引号里的hello world!换成别的文本：

```rust
fn main(){
    println!("你好，世界!");
}
```

这段程序将打印出中文的```你好，世界!```，是不是很惊讶，这是因为Rust语言默认使用utf8编码，因此可以处理中文字符串！  
